<?php
/***************************************
  Show AuroraCalendar by precreated png file
  Refresh page in HTML to run update
***************************************/

include_once (__DIR__ ."/include/myauroravar.php");
include_once (__DIR__ ."/include/MoonTime.php");
include_once (__DIR__ .'/MoonPhase.php');

include_once (__DIR__ .'/djgweather.php');

// Set the content-type
//header('Content-Type: image/png');

define ("FONT8SEG", __DIR__ ."/include/Segment7Standard.otf");
define ("FONTTEXT", __DIR__ ."/include/segmono_boot.ttf");
	define ("REFX",10);	//offset 13
	define ("REFY",10);	//ofset 13
	define ("CW",960);
	define ("CH",300);
	define ("PPH", 24);		// 24px/hour
	define ("PPK", 7);		// 8px/kp
	define ("WW", 72*PPH);
	define ("WH", 14*PPK);
	define ("FH", 0);		//frame H width
	define ("FW", 0);		//frame V width
	define ("HTXT", 0);		//frame H width

	define ("FTH", 32);		//Frame Top Height
	define ("FBH", 32);		//Frame Bottom Height
	define ("FLW", 20);		//Frame Left Width
	define ("FRW", 20);		//Frame Right Width
	define("DAYW", 24*PPH+FLW+FRW);
	//define("DAYH", 100);
	define ("DBG", 1);
/*
session_start(); 
if(isset($_SESSION['loc'])){
	$locID=$_SESSION['loc'];
	define ("DBG", 0);
}
else {
	define ("DBG", 1);
	$locID="Yellowknife";	//vancouver
	$locID="Vancouver";	//vancouver
	//$locID="Tromso";
	//$locID="Reykjavik";
	//$locID="Calgary";
}
*/
if(DBG){
	$lat=$locinfo[$locID][2];
	$lon=$locinfo[$locID][3];
	echo "$locID lat: $lat  lon: $lon";		//debug
}
$timezone=$locinfo[$locID][5];

date_default_timezone_set($timezone);
//$TZ=idate('Z')/3600;
//$tm=date("Y-m-d H:i", time());
//echo "<h1> $tm 观赏点: $locID <br>";
$kpPath="kp/";
$kpPath="http://dajiguang.com/mydata/kp";

$json=file_get_contents ($kpPath ."/kpData.json");
$kpdata=json_decode($json, true);
//var_dump($kpdata);
$kp72h=$kpdata['kp72h'];
$kp45d=$kpdata['kp45d'];
$kpStatus=$kpdata['kpStatus'];
//read kp & infomaition
$fn=$kpStatus['kpfile'];
$kp=$kp72h['kp72h'];


/* Sun infomaition
About brightness of twilight
http://iopscience.iop.org/article/10.1088/1742-6596/771/1/012033/pdf
*/	

$lati=$locinfo[$locID][2];
$long=$locinfo[$locID][3];;	//Vancouver Latitude and 

//$tm=time();
/*special debug: 
//Yellowknife May 16-26 CE=00~01am
//Tromso 4/10

*/
if(DBG) $kp72h['ftime']=mktime(0,0,0,11,12,2017);
$tm=$kp72h['ftime'];
/*
//sunrise&&sunset==TRUE  No night
//sunrise&&sunset==FALSE  No day

*/

$sun_info = date_sun_info($tm, $lati, $long);
if(0)// (DBG)
{
	var_dump($sun_info);
	echo  date("Y-m-d H:i:s <br>", $tm);
	foreach ($sun_info as $key => $val) {
		echo  "<br>$key ($val): " . date("Y-M-d H:i:s", $val) . "\n";
	}
}
$sInfo=skyLight3Days($tm, $lati, $long);
/*  Make twilight sequences by time */
function skyLight3Days($dt, $lati, $long){
	$tm=$dt;	//-86400;		//start from previous day
	$sInfo=array();
	for($i=0;$i<4; $i++){
		$sInfo[$i] = date_sun_info($tm, $lati, $long);
		asort($sInfo[$i], SORT_NUMERIC );
		if(($sInfo[$i]['sunrise']===TRUE)&&($sInfo[$i]['sunset']===TRUE))
			$sInfo[$i]['DnN']='D';
		else if(($sInfo[$i]['sunrise']===FALSE)&&($sInfo[$i]['sunset']===FALSE))
			$sInfo[$i]['DnN']='N';
		else $sInfo[$i]['DnN']=0;
		$tm+=86400;
	}

	return $sInfo;

}
//echo  $locID .$timezone ."Lat: $lati  Long: $long <br>";
//$isky=drawSky0($sun_info);
$isky=draw1Day($sInfo, 0, $tm);
$im=draw3dayKp($kp, $isky);

// draw moon phase and position
$moont=moonTime3Days($tm, $lati, $long);

drawMoons($im, $tm);

//draw weather icon
$loc=$locinfo[$locID][0];		//city name(for UW weather)
updateWeather($loc);
$fcsv=__DIR__ ."/weather/" .$loc. ".csv";
$dat=csv_to_array($fcsv);
$bt=$dat[0]['epoch'];
//var_dump ($dat[239]);
//echo "<br>". date("Y-m-d H:i:s",$bt);

if(!DBG)
	drawWeather($im, $dat);

//cut to 3 days
cutTo3days($im, $locID);


imagepng($im, "kp/daykp.png");
imagedestroy($im);
if(DBG) echo  '<br> <img src="kp/daykp.png"  style="width:100%" /> <br>';		//test

//echo  '<img src="kp/threeDays.png" width=100% /> ';		//test
//echo  '<br> <img src="kp/day1.png"  /> ';		//test
//echo  '<br> <img src="kp/day2.png" style="width:100%" /> ';		//test
//echo  '<br> <img src="kp/day3.png" style="width:100%" /> <br>';		//test

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//

/*=======================================================*/
function cutTo3days($im, $locID)
{
	global $kp72h, $locinfo;
	$ftime=$kp72h['ftime'];
	$sh=imagesy ($im);
	$dh=$sh+FTH+FBH;
	$imday1=imagecreatetruecolor(DAYW, $dh);
	$im3day=imagecreatetruecolor(DAYW, $dh*3);
	$white = imagecolorallocate($im, 240, 240, 240);
	$dBlue = imagecolorallocate($im, 13, 13, 113);
	$green = imagecolorallocate($im, 13, 200, 13);
	$red = imagecolorallocate($im, 240, 50, 50);
	$y0=24;		//top text
	$x0=10;
	$fs=14;
	$tt=date("H:00 Y-m-d", $ftime);
	$loc=$locinfo[$locID][0] .", " .$locinfo[$locID][6];
	$xkp=$sh+FTH-4;
	imagefilledrectangle($imday1, 0, 0, DAYW, $dh, $dBlue );
	imagefilledrectangle($im3day, 0, 0, DAYW, $dh*3, $dBlue );
	imagettftext($imday1, $fs, 0, $x0, $y0, $white, FONTTEXT, $tt);
	imagettftext($imday1, $fs, 0, $x0+DAYW/2, $y0, $white, FONTTEXT, $loc);
	imagettftext($imday1, 10, 0, FLW-12, $xkp, $white, FONT8SEG, '1');
	global $kpcolor;
	$c5=imagecolorallocate($imday1 ,$kpcolor[5]['r'], $kpcolor[5]['g'], $kpcolor[5]['b']);
	imagettftext($imday1, 10, 0, FLW-10, $xkp-24, $c5, FONT8SEG, '5');
	$c9=imagecolorallocate($imday1 ,$kpcolor[9]['r'], $kpcolor[9]['g'], $kpcolor[9]['b']);
	imagettftext($imday1, 10, 0, FLW-10, $xkp-48, $c9, FONT8SEG, '9');
//
	$i=0;
	$sw=24*PPH;
	imagecopyresampled($imday1, $im, FLW, FTH, $i*24*PPH,0,$sw, $sh, $sw, $sh);
	drawTimeTick($imday1, $white, $green);
	imagepng ($imday1,"kp/day1.png" ); 
	imagecopyresampled($im3day, $imday1, 0, 0, 0, 0, DAYW, $dh, DAYW, $dh);
	
	$gap=8;
	$i++;
	$tt=date("H:00 Y-m-d", $ftime+$i*86400);
	imagefilledrectangle($imday1, 0, 0, DAYW, $y0+4, $dBlue );		//erase
	imagettftext($imday1, $fs, 0, $x0, $y0, $white, FONTTEXT, $tt);
	imagecopyresampled($imday1, $im, FLW, FTH, $i*24*PPH,0,$sw, $sh, $sw, $sh);
	imagepng ($imday1,"kp/day2.png" ); 
	imagecopyresampled($im3day, $imday1, 0, $dh-$gap, 0, 0, DAYW, $dh, DAYW, $dh);
	
	$i++;
	$tt=date("H:00 Y-m-d", $ftime+$i*86400);
	imagefilledrectangle($imday1, 0, 0, DAYW/2, $y0, $dBlue );
	imagettftext($imday1, $fs, 0, $x0, $y0, $white, FONTTEXT, $tt);
	imagecopyresampled($imday1, $im, FLW, FTH, $i*24*PPH,0,$sw, $sh, $sw, $sh);
	imagepng ($imday1,"kp/day3.png" ); 
	imagecopyresampled($im3day, $imday1, 0, ($dh-$gap)*2, 0, 0, DAYW, $dh, DAYW, $dh);
	
	$ftime=$kp72h['itime'];
	$tt="Update " . date("H:i Y-m-d", $ftime);

	imagettftext($im3day, $fs, 0, DAYW/2-30, $dh*3-7, $white, FONTTEXT, $tt);
	imagepng ($im3day,"kp/threeDays.png" ); 
		
	imagedestroy($imday1);
	imagedestroy($im3day);
	
}

function drawTimeTick($im, $white, $green){
	$sh=imagesy ($im);
	$x1=FLW;
	$x0=FLW;
	$y0=FTH+WH-4;	
	$i=0;
	for($i=0; $i<25; $i++){
	// tick mark for time	
		$j=$i+date('Z')/3600;
	//	$j=$i-9;
			if($j<0) $j+=24;
			$j=$j%24;
		if($j%3==0){	//tick white and number
			imagefilledrectangle($im, $x1-1, $y0+5, $x1+1, $y0+8, $white); 

			$dd=sprintf("%02d", $j);
			imagettftext($im, 11, 00, $x0+$i*PPH-10, $y0+24, $green, FONT8SEG, $dd);
		}
		else{		//tick green
			imagefilledrectangle($im, $x1-1, $y0+5, $x1+1, $y0+8, $green); 

		}
		$x1 +=PPH;

	}
	
	
}
/*-------------------------------------------------------*/

function drawMoons($im, $ftime)
{
	global $mt, $cycl, $white;
	
	$moonphase=@imagecreatefrompng(__DIR__ .'/Phases30.png');		//moon phase pic
	//echo "sx:$sx  sy:$sy";
	$ftime=(int)($ftime/86400);
	$ftime *=86400;
//	var_dump($mt);
	for($k=0; $k<4; $k++)		// 4?3?
	{
		$k1=2*$k;
		$date1=$mt[$k1][0];
		$h=($date1-$ftime)/3600;	// >0 start from same day, else from previous day
		$a1x=$h*PPH;
		$d=$mt[$k1][3]*PPH;
		$h=8*PPK;
		$a2x=$a1x+$d;
	//	echo "<br>a1x $a1x  $d";
		$r=TwoDotToCircle($d, $h);
		$a=asin(($d/2)/$r);
		$a=$a*57.3;
		$a=round($a,0);
	//	echo "  alfa= $a r=$r";

		$cx=($a1x+$a2x)/2;
		$y0=WH;
		$white=imagecolorallocatealpha($im, 254, 254, 254, 0);
//moon phase		
//		$moondata = phase($ftime+$k*86400);
		$moondata = phase($date1);
		$age=round($moondata[2]);		//moon age
		if($age<0) $age=0;
		$sy=0;
		if ($age>=15) {
			$sy=16;
			$age-=15;
		}
		$sx=$age*16;
		
		imagearc($im, $cx, $y0-$h+$r,$r*2, $r*2, 270-$a, 270+$a, $white);
		$cx=round($cx/PPH, 0);	//void split to half moon, but chance of no moon in 24 hours
		$cx *=PPH;
		imagecopy($im, $moonphase, $cx+3, $y0-$h-8, $sx, $sy, 16, 16 );
	//	imagecopy($im, $moonphase, $cx+PPH+8, $y0-$h-3, $sx, $sy, 16, 16 );
	//	imagecopy($im, $moonphase, $cx-PPH+8, $y0-$h-5, $sx, $sy, 16, 16 );
	
	}
	
//	echo "<br>h:$h  date: " .gmdate("Y-m-d H:i:s", $date1);
//	echo "<br>fdate: " .gmdate("Y-m-d H:i:s", $ftime);
//	echo "<br>idate: " .idate("H", $ftime);
	$i=0;
	$v=$mt;
/*
	for($i=0; $i<9; $i++ ){
		echo "<br>" .$mt[$i][1]  .date("Y-m-d H:i:s", $mt[$i][0]);

	}
*/	
//var_dump ($cycl);
	
	
// moon time	
	
}
/*-------------------------------------------------------*/
function drawWeather($im, $w10h)
{
	global $kp72h, $sun_info;
/*
	$wIcons=imagecreatefrompng(__DIR__ .'/include/weatherIcons.png');
	$dCode=array(0,7,7,2,8,5,6,7,8,9,10,11,0,4,3,15,16,17,18,19,1,21);
	$nCode=array(0,6,6,5,8,5,6,7,8,9,10,11,0,4,3,15,16,17,18,19,1,21);
*/
	$wIcons=imagecreatefrompng(__DIR__ .'/include/wicon24.png');
	$dCode=array(0,0,2,4,6,5,6,7,8,9,10,11,8,9,10,11,16,17,18,12,12,13);
	
	$nCode=array(0,1,3,5,7,5,6,7,8,9,10,11,8,9,10,11,16,17,18,12,12,13);
	$wtime=$w10h[0]['epoch'];		//start time;
//	echo "weather from: " .date("Y-m-d H:i:s", $wtime);
//	echo "<br> predic date: " .date("Y-m-d H:i:s", $kp72h['ftime']);
	$xbt=($wtime-$kp72h['ftime'])/3600;
	
	$hsunrise=$sun_info['sunrise'];
	$temp=$sun_info['civil_twilight_begin'];
	if($hsunrise===TRUE){
		if($temp===TRUE)
			$dn='polarDay';
		else
			$dn='polarNight';
	}
	else{
		$dn='normal';
		$hsunrise=getdate($hsunrise);
		$hsunset=getdate($sun_info['sunset']);
	}
	//test
	for($i=0; $i<72-$xbt; $i++){
		$wcode=$w10h[$i]['fctcode'];
		if($dn=='polarDay')
			$code=$dCode;
		else if($dn=='polarNight')
			$code=$nCode;
		else{
			$h=getdate($w10h[$i]['epoch']);
			if(($h['hours']>$hsunrise['hours'] )&&($h['hours']<$hsunset['hours'] ))
				$code=$dCode;
			else	
				$code=$nCode;
		}
		$j=$code[$wcode];
		if($j<14)
			imagecopy($im, $wIcons, ($xbt+$i)*PPH, 5, $j*24, 0, 24, 24 );
	}
	
}
/*-------------------------------------------------------*/
function mkPal($im, $rgb){
	return imagecolorallocate($im, $rgb[0], $rgb[1] ,$rgb[2]);
}

function drawAllDay($isky, $col, $pph, $h)
{
	$rgb=HSLToRGB($col[0],$col[1],$col[2]);
	$cb=mkPal($isky, $rgb);
	imagefilledrectangle($isky ,0 ,0 ,12*$pph ,$h, $cb);

}
function drawTwi($isky, $xb, $xe, $cb, $ce, $ish)
{
	$rgb=HSLToRGB($col[0],$col[1],$col[2]);
	$cb=mkPal($isky, $rgb);
	imagefilledrectangle($isky ,0 ,0 ,12*$pph ,$h, $cb);

}


function draw3dayKp($kp, $isky){
	
	global $kp72h;
	$kp=$kp72h['kp72h'];
	//$kp='444333222111999222555666777888222000111222222222233322222211122222222222';
	for($i=0; $i<72; $i++){
		$kpi[]=intval(substr($kp, $i ,1));
	}
	

	$w=WW+FW *2;
	$htxt=HTXT; ;		//height for time text
	$h=WH+FH*2+$htxt;
	//Sky frame
	$im=imagecreatetruecolor ($w ,$h);

	// Create some colors
	$bright = imagecolorallocate($im, 240, 240, 240);
	$white = imagecolorallocate($im, 255, 255, 255);
	$grey = imagecolorallocate($im, 128, 128, 128);
	$blue = imagecolorallocate($im, 0 ,0 ,255);
	$green = imagecolorallocate($im, 0 ,255, 31);
	$red = imagecolorallocate($im, 255 ,0 ,31);
	$black = imagecolorallocate($im, 3, 3, 3);
	$font=FONT8SEG;
	
	$y0=$h-FH-$htxt;		//from bottom

	imagefilledrectangle ($im ,0, 0, $w, $h, $black);
	imagefilledrectangle ($im ,FW, FH, $w-FW, $y0, $grey);	//day

		
		$tz=date('Z')/3600;		//hour
		if(DBG) echo  "<br> TZ: $tz";
		if($tz<0){
			$tz+=24;
		}
		imagecopyresampled($im, $isky, FW, FH, $tz*PPH, 0,PPH*12*4, WH, PPH*12*4, WH  );
		imagecopyresampled($im, $isky, FW+24*PPH, FH, $tz*PPH, 0,PPH*12*4, WH, PPH*12*4, WH  );
		imagecopyresampled($im, $isky, FW+48*PPH, FH, $tz*PPH, 0,PPH*12*4, WH, PPH*12*4, WH  );
		
		imagepng($isky, "kp/temp.png");	
		imagedestroy($isky);

	//var_dump($suntime);
	{
	/*  plot 72 hours  */
	$x0=FW+1;		//offset 1

	global $kpcolor;
	//if(DBG) echo  date('Z')/3600;
	for($i=0; $i<72; $i++){ 
		$k=$kpi[$i];	//0-9
		$r=$kpcolor[(string)$k]['r'];
		$g=$kpcolor[(string)$k]['g'];
		$b=$kpcolor[(string)$k]['b'];
		$col=imagecolorallocate($im ,$r ,$g ,$b);
		$x1=$x0+$i*PPH;
		$y1=$y0-$k*PPK;
	// draw vertical with current Kp	
		if($i>0){
			$y2=$y0-$kpi[$i-1]*PPK;
	//		imagefilledrectangle($im, $x1, $y1, $x1+1, $y2+1, $col);
		}
	//plot slope of Kp, thickness=2
	//	imagefilledrectangle($im, $x1+1, $y1, $x1+PPH+1, $y1+1, $col);
		
		imagefilledrectangle($im, $x1+1, $y0, $x1+PPH-1, $y1, $col); // unfilled rectangle
		//imagerectangle($im, $x1+1, $y0, $x1+PPH-1, $y1, $col); // unfilled rectangle
/*
	// tick mark for time	
		$j=$i+date('Z')/3600;
	//	$j=$i-9;
			if($j<0) $j+=24;
			$j=$j%24;
			$x1 +=1;
		if($j%3==0){	//tick white and number
			imagefilledrectangle($im, $x1-1, $y0+5, $x1+1, $y0+8, $white); 

			$dd=sprintf("%02d", $j);
			imagettftext($im, 11, 00, $x0+$i*PPH-10, $y0+HTXT-2, $green, $font, $dd);
		}
		else{		//tick green
			imagefilledrectangle($im, $x1-1, $y0+5, $x1+1, $y0+8, $green); 

		}
	*/	
	}

	$x1=0;
	$y1=0;
	$cbg1=imagecolorallocate ($im ,38 ,38 ,38); //date of update, background color RGB(38,38,38)

	//imagefilledrectangle ($im ,$x1, $y1, $x1+120, $y1+40 ,$grey);
	// Show issue date
	$itime=$kp72h['itime'];
	$itime=time();
		$dd=date("Y-m-d",$itime) ;     //locate time of update, background color RGB(38,38,38)
		$dt=date("H:i T",$itime) ; 

	//	imagettftext($im, 20, 00, REFX+5, REFY+20, $white, $font, $dd);
	//	imagettftext($im, 18, 00, REFX+5, REFY+60, $white, $font, $dt);



	//fillGradientRec($im, $fvar);

	}	
	return $im;
	
}
/*------------------- draw sky -------------------------*/
// Civil twilight total= (Sunrise-CWB)+(CWE-Sunset)
// Tromso Nov 26: last sunrise,daylight 1h02m
//		  Jan 15: first sunrise, daylight 0h57m
//        May 17: last civil, 1h09m
//		  Jul 26: first civil, 0h42m

/*    Bug: 00am overlap. 
To be rewriting, chain from noon time of previous day
	*/
function getHours($tm){
	$h=round($tm/3600, 4);
	echo  "<br>hour= $h";
	return $h*PPH;
}
	
function draw1Day($sInfo, $dt, $sttime)
{
//	global $twicol;
	define("H00", 154);		//138/255 sky blue
	define("S00", 255);		//154/147 less saturation
	$twicol=[
		'tr'  => [H00,S00,250],	//transit	
		'cb'  => [H00,S00,180],		//1 hour before set
		'cw'  => [H00,S00,160],		//civil end, nauti begin
		'nw'  => [H00,S00,120],		// Nauti end, Astro begin
		'aw'  => [H00,S00,90],
		'night' => [H00,S00,10],
		'day'  =>[H00,S00,200],
	];
	//1. Fill sunset-1 to CTWI-end,
	//HSL color
	//148/200
	$i=0;
	for($ii=0; $ii<4; $ii++){
		$sun=$sInfo[$ii];
	
		foreach ($sun as $key => $val) {
			$SI4Days[$i][0]=$key;

			if(($val===TRUE)||($val===FALSE)){	//==1 no TWI
				$t='---';
				$SI4Days[$i++][1]=0;
			} 
			else if($key=='DnN'){
				$t=$sun['DnN'];
	//			$SI4Days[$i++][1]=0;
			}
			else {
				$t=date("M-d H:i:s", $val);
				$SI4Days[$i++][1]=$val;
			}
//			echo  "<br>$key: $t \n";
		}
	}
	$items=$i;
	var_dump($sun);
	//var_dump($SI4Days);

	$isw=90*PPH;		//prepare 2 days for cut and copy
	$ish=WH;
	//PPH=24;		//test
	$isky=imagecreatetruecolor($isw, $ish);
	
	$white = imagecolorallocate($isky, 255, 255, 255);
	$grey = imagecolorallocate($isky, 128, 128, 128);
	$blue = imagecolorallocate($isky, 0 ,0 ,255);

	imagefilledrectangle($isky, 0, 0, $isw, $ish, $grey);
	// Null===TRUE
	$ae=$sInfo[$dt]['astronomical_twilight_end'];
	$ne=$sInfo[$dt]['nautical_twilight_end'];
	$ce=$sInfo[$dt]['civil_twilight_end'];
	$ab=$sInfo[$dt]['astronomical_twilight_begin'];
	$nb=$sInfo[$dt]['nautical_twilight_begin'];
	$cb=$sInfo[$dt]['civil_twilight_begin'];
	$ate=getdate($ae);	//local time, int
	$nte=getdate($ne);	//local time, int
	$cte=getdate($ce);	//local time, int
	$atb=getdate($ab);	//local time, int
	$ntb=getdate($nb);	//local time, int
	$ctb=getdate($cb);	//local time, int

	$cb=$twicol['night'];
	$xb=0;		//midnight
	$xe=12*PPH;
//	
	$t=$sInfo[$dt]['DnN'];

	if($t==='D' ){//No Night, skip the others
		$cb=$ce=$twicol['day'];
		$xe=24*PPH;		//24 hours
		fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
		echo"<br> $t Day!!! <br>";
		return $isky;
	}

	for($i=0; $i<$items; $i++){
		if($SI4Days[$i][0]=='transit') break;
	}
	if($sInfo[0]['sunrise' ]===FALSE){
		$cb=$twicol['cw'];
	}
	else {
		$cb=$twicol['day'];
	}
	$xx=$sInfo[0]['transit'];
	$xb=getHours($xx-$sttime);
	$t=date("Y-M-d H:i:s", $xx);
	
	echo "<br> transit $t ";
	$midnight=$SI4Days[$i][1]+12*3600;		//midnight time
	$period='TWI';
	$i++;		//skip 1st transit
	for(; $i<$items; $i++){
		switch($SI4Days[$i][0]){
			case 'sunset':
				$tm=$SI4Days[$i][1];
				$ce=$twicol['day'];
				$xe=getHours($tm-$sttime);
				fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
				$xb=$xe;
				$cb=$ce;
				break;
			case 'civil_twilight_end':
				$tm=$SI4Days[$i][1];
				if($tm){
					$ce=$twicol['cw'];
					$xe=getHours($tm-$sttime);
					fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
					$xb=$xe;
					$cb=$ce;
				}
				else{
					
				}
				break;
			case 'nautical_twilight_end':
				$tm=$SI4Days[$i][1];
				if($tm){
					$ce=$twicol['nw'];
					$xe=getHours($tm-$sttime);
					fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
					$xb=$xe;
					$cb=$ce;
				}
				else{
					
				}
				break;
			case 'astronomical_twilight_end':
				$tm=$SI4Days[$i][1];
				if($tm){
					$ce=$twicol['aw'];
					$xe=getHours($tm-$sttime);
					fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
					$xb=$xe;
					//draw night AWe to midnight
					$cb=$twicol['night'];
					if(DBG) echo "<br>midnight " .date("Y-M-d H:i:s", $midnight);
					if(DBG) echo "<br>ate " .date("Y-M-d H:i:s", $tm);
					$xe=getHours($midnight-$sttime);
					$ce=$cb;
					fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
					$xb=$xe;
				}
				else{
					
				}
				break;
			case 'astronomical_twilight_begin':		//night to AWb
				$tm=$SI4Days[$i][1];
				if($tm){
					$period='midnight';		//night to night end
					$ce=$twicol['night'];
					$xe=getHours($tm-$sttime);
					fillHsl($isky, $xb, $xe, $cb, $ce, $ish, $period);
					$xb=$xe;
					$cb=$twicol['aw'];
				}
				else{
					
				}
				break;
			case 'nautical_twilight_begin':
				$tm=$SI4Days[$i][1];
				if($tm){
					$period=' AW';
					$ce=$twicol['nw'];
					$ce=$twicol['aw'];		//debug
					$xe=getHours($tm-$sttime);
					fillHsl($isky, $xb, $xe, $cb, $ce, $ish, $period);
					$xb=$xe;
					$cb=$ce;
				}
				else{
					
				}
				break;
			case 'civil_twilight_begin':
				$tm=$SI4Days[$i][1];
				if($tm){
					$ce=$twicol['cw'];
					$ce=$twicol['nw'];	//debug
					$xe=getHours($tm-$sttime);
					fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
					$xb=$xe;
					$cb=$ce;
				}
				else{
					
				}
				break;
			case 'sunrise':
				$tm=$SI4Days[$i][1];
				if($tm){
					$ce=$twicol['day'];
					$ce=$twicol['cw'];		//debug

					$xe=getHours($tm-$sttime);
					fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
					$xb=$xe;
					$cb=$ce;

				}
				else{
					
				}
				break;
			case 'transit':
				$tm=$SI4Days[$i][1];
				$midnight=$tm+12*3600;		//renew
				if($tm){
					$ce=$twicol['day'];
					$xe=getHours($tm-$sttime);
					fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
					$xb=$xe;
					$cb=$twicol['day'];
				}
				else{
					
				}
				break;
		}
	}
	return $isky;
}

function drawSky0($sun_info)
{
	//1. Fill sunset-1 to CTWI-end,
	//HSL color
	//148/200
	define("H00", 154);		//138/255 sky blue
	define("S00", 255);		//154/147 less saturation
	$twicol=[
		'tr'  => [H00,S00,250],	//transit	
		'cb'  => [H00,S00,180],		//1 hour before set
		'cw'  => [H00,S00,160],		//civil end, nauti begin
		'nw'  => [H00,S00,120],		// Nauti end, Astro begin
		'aw'  => [H00,S00,90],
		'night' => [H00,S00,10],
		'day'  =>[H00,S00,200],
	];

	$isw=48*PPH;		//prepare 2 days for cut and copy
	$ish=WH;
	//PPH=24;		//test
	$isky=imagecreatetruecolor($isw, $ish);
	$white = imagecolorallocate($isky, 255, 255, 255);
	$grey = imagecolorallocate($isky, 128, 128, 128);
	$blue = imagecolorallocate($isky, 0 ,0 ,255);

	//imagefilledrectangle($isky, 0, 0, $isw, $ish, $red);
	// Null===TRUE
	$ae=$sun_info['astronomical_twilight_end'];
	$ne=$sun_info['nautical_twilight_end'];
	$ce=$sun_info['civil_twilight_end'];
	$ab=$sun_info['astronomical_twilight_begin'];
	$nb=$sun_info['nautical_twilight_begin'];
	$cb=$sun_info['civil_twilight_begin'];
	$ate=getdate($ae);	//local time, int
	$nte=getdate($ne);	//local time, int
	$cte=getdate($ce);	//local time, int
	$atb=getdate($ab);	//local time, int
	$ntb=getdate($nb);	//local time, int
	$ctb=getdate($cb);	//local time, int

	$cb=$twicol['night'];
	$xb=0;		//midnight
	$xe=12*PPH;
	$step=$sun_info['astronomical_twilight_begin'];
	if($step===TRUE)
	{
		$cb=$twicol['aw'];		//start from ATW
			if(DBG) echo  "<br> No ATW begin $xe ";
	}
	else
	{
		$ce=$twicol['night'];
		$xe=($atb['hours']+$atb['minutes']/60)*PPH;
		if(DBG) echo  "<br>ATwi b: $xb e: $xe";
		fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
		$xb=$xe;
		$cb=$ce;
	}
	$step=$sun_info['nautical_twilight_begin'];
	if($step===TRUE)
	{
		$cb=$twicol['nw'];		//start from NTW
		$xe=12*PPH;
		if(DBG) echo  "<br> No NTWi begin: $xe";
	}
	else
	{
		$ce=$twicol['aw'];
		$xe=($ntb['hours']+$ntb['minutes']/60)*PPH;
		if(DBG) echo  "<br>NTWi b: $xb e: $xe ---";
		fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
		$xb=$xe;
		$cb=$ce;
	}
	/*
	Tromso Apr/25 , Civil Twi start from 23:50, early than midnight
	*/
	$step=$sun_info['civil_twilight_begin'];
	if(($step===TRUE)||($ctb['hours']>11))	
	{
		$cb=$twicol['day'];		//start from CTW
		$xe=24*PPH;
		if(DBG) echo  "<br> No CTWi begin: $xe ---";
	}
	else
	{
		$ce=$twicol['nw'];		//end with NW
		$xe=($ctb['hours']+$ctb['minutes']/60)*PPH;
		$bc=$cb[2];			// ... civil end after 0am, Yellowknife May 18
		if(DBG) echo  "<br>CTWi b: $xb e: $xe cb: $bc ---";
		fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
		$xb=$xe;		
		$cb=$ce;		//begin with NW
		$xe +=PPH;		//1hour after sun rise;
		$ce=$twicol['day'];
		if(DBG) echo  "<br>ToDay b: $xb e: $xe ---";
		fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
		$xb=$xe;
		$cb=$ce;
		$xe=12*PPH;
	}

		if(DBG) echo  "<br> End to Noon b: $xb  e: $xe ---";

		$ce=$twicol['day'];
		fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
		$xb=$xe;
		$cb=$ce;
		//if(DBG) echo  "<br> b: $xb  e: $xe <br>";
	//------------- Noon
	$step=$sun_info['civil_twilight_end'];
	if(($step===TRUE)||($cte['hours']<11))
	{
		$ce=$twicol['day'];		//start from CTW
		$xe=24*PPH;
		if(DBG) echo  "<br>no CTWI end $xb ---";
	}
	else
	{
		if(DBG) echo  ("<br> Pre CTWi ---");
		$ce=$twicol['day'];
		$xc=($cte['hours']+$cte['minutes']/60)*PPH;
		$xe=(int)$xc-PPH;		//1 hour before
		fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
		if(DBG) echo  ("<br> CTWi end ---");

		$cb=$ce;
		$ce=$twicol['nw'];
		$xb=$xe;
		$xe=$xc;
		if(DBG) echo  ("<br> end to NTWi ---");
		fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
		$xb=$xe;
		$cb=$ce;
	}

	//ate passed T00 @Apr-10 Tromso, ignore. Likewise Civil begin to early
	$step=$sun_info['nautical_twilight_end'];
	if(($step===TRUE)||($nte['hours']<12))	
	{
		$ce=$twicol['nw'];		//end from NTW
		$xe=24*PPH;
		if(DBG) echo  "<br>no NTWI end $xb ---";
	}
	else
	{
		$ce=$twicol['aw'];
		$xe=($nte['hours']+$nte['minutes']/60)*PPH;
		if(DBG) echo  ("<br> NTWi end to ATWI b:$xb e:$xe ---");
		fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
		$xb=$xe;
		$cb=$ce;
	}

	$step=$sun_info['astronomical_twilight_end'];
	if($step===TRUE)
	{
		$ce=$twicol['aw'];		//start from NTW
		$xe=24*PPH;
		if(DBG) echo  "<br>no ATW end $xb ---";
	}
	else
	{
		$ce=$twicol['night'];
		$xe=($ate['hours']+$ate['minutes']/60)*PPH;
		if($xe<$xb) $xe=24*PPH;		//ate is >00am 
		if(DBG) echo  "<br>ATWi b:$xb e:$xe ---";
		fillHsl($isky, $xb, $xe, $cb, $ce, $ish);
		$xb=$xe;
		$cb=$ce;
		$xe=24*PPH;
	}
		
	{	
		if(DBG) echo  "<br>To T00 b:$xb e:$xe ---";
		
	//	$ce=$twicol['night'];
		fillHsl($isky, $xb, $xe, $cb, $ce, $ish);

	}
		imageline($isky, 0+1, 0, 0+1, $ish, $blue);
		imageline($isky, PPH*12+1, 0, PPH*12+1, $ish, $white);

		
	//-----------------------------------------------------//
	//1. midnight to Civil Twi
		imagecopyresampled($isky, $isky, PPH*24, 0, 0,0, PPH*24, $ish, PPH*24, $ish  );
	//	var_dump ($sun_info);

	return $isky;
}
/*-------------------------------------------------------------------------------*/
/*  据等腰三角形的底边长河高求外接圆直径。
 $d  底边长
 $h:  高
 圆心到两底的扇形张角：
  asin(($d/2)/$r) (弧度)
	弧度*57.3=度
 --------------------*/
function TwoDotToCircle($d, $h)
{
	$xi=$d/2;
	$alf=atan($xi/$h);
	$l=$h / cos($alf);
	$l /=2;
	$r=$l/cos($alf);
	return $r;
}

/* 
start color: white
end color: dark blue
*/
/*
$gcolor=[
//				R    G   B
	"begin" => [254,254,254],
	"end" =>[1,1,11]	,
	"step" =>[2.2, 2.2, 1],
];

function fillGradientArc($im, $deg0, $deg, $gcolor){
	global $bg;
	$r=$gcolor["begin"][0];
	$g=$gcolor["begin"][1];
	$b=$gcolor["begin"][2];
	
	for ($x=0; $x<$deg; $x++){
		if($r>$gcolor["end"][0]) $r-=$gcolor["step"][0];
		if($g>$gcolor["end"][1]) $g-=$gcolor["step"][1];
		if($b>$gcolor["end"][2]) $b-=$gcolor["step"][2];
		$color=imagecolorallocatealpha($im, $r, $g, $b, 0);
		imagefilledarc ($im, 300, 300, 400, 400, $deg0+$x, $deg0+$x+1, $color, IMG_ARC_EDGED);
	}
	imagefilledarc ($im, 300, 300, 300, 300, $deg0, $deg0+$deg+1, $bg, IMG_ARC_EDGED);

}

*/
/*----------------------------------------------------------------------
function fillGradientRec($im, $fvar){		//direction
	//global $r0, $g0, $b0;
	$stpr=$fvar['bcol'][0]-$fvar['ecol'][0];
	$len=$fvar['ex']-$fvar['bx'];		//can be negative
	$stpr /=$len;
	$stpb=$fvar['bcol'][2]-$fvar['ecol'][2];
	$stpb /=$len;
	$stpg=$fvar['bcol'][1]-$fvar['ecol'][1];
	$stpg /=$len;
	$r0=$fvar['bcol'][0];
	$b0=$fvar['bcol'][2];
	$g0=$fvar['bcol'][1];
	if(DBG) echo  "<br> $len " .$stpr .' '.$stpg .' '.$stpb .' <br>';
	//if(DBG) echo  $stpr.$stpg .$stpb;
	for ($x=$fvar['bx'] ;$x<$fvar['ex'] ;$x++){
		if($r0)
			$r0-=$stpr;
		if($g0)
			$g0-=$stpg;
		if($b0>0)
			$b0-=$stpb;
		$color=imagecolorallocatealpha($im, $r0, $g0, $b0, 0);
	//	for($y=$fvar['by'];$y<$fvar['ey'];$y++){
			imageline($im,$x,$fvar['by'], $x, $fvar['ey'] , $color);
		
	//	}
	}
}	-*/
/*
  Gradient with HSL
*/

function fillGradientHsl($im, $fvar){		//direction
	//global $r0, $g0, $b0;
	$bhsl=$fvar['bcol'];
	$ehsl=$fvar['ecol'];
	$stpl=$bhsl[2]-$ehsl[2];
	$len=$fvar['ex']-$fvar['bx'];		//can be negative
	$stpl /=$len;
	if(DBG) echo  $stpl;
	//if(DBG) echo  $stpr.$stpg .$stpb;
	for ($x=$fvar['bx'] ;$x<$fvar['ex'] ;$x++){
		$rgb=HSLToRGB($bhsl[0] ,$bhsl[1] ,$bhsl[2]);
		$color=imagecolorallocatealpha($im, $rgb[0], $rgb[1], $rgb[2], 0);
		imageline($im,$x,$fvar['by'], $x, $fvar['ey'] , $color);
		$bhsl[2]-=$stpl;	//Brightness
		if($bhsl[2]<$ehsl[2])
			$bhsl[2]=$ehsl[2];
	}
}	

function fillHsl($im, $xb, $xe, $bhsl, $ehsl, $h, $period='~~~')
{	
	//$pph=12;
	$xe=round($xe, 0);
	$xb=round($xb, 0);
	$len=$xe-$xb;		//can be negative
		$rgb=HSLToRGB($ehsl[0] ,$ehsl[1] ,$ehsl[2]);
		$color=imagecolorallocatealpha($im, $rgb[0], $rgb[1], $rgb[2], 0);
	//	imageline($im,$x,0, $x, $h , $color);
	imagefilledrectangle($im, $xb, 0, $xe, $h, $color);

	
	if(DBG) echo  "<br>Period: $period b:$xb e:$xe  light:$bhsl[2]->$ehsl[2] ($len) <br>";
	return $xe;
}	
function fillHsl0($im, $xb, $xe, $bhsl, $ehsl, $h, $period='~~~')
{	
	//$pph=12;
	$xe=round($xe, 0);
	$xb=round($xb, 0);
	$len=$xe-$xb;		//can be negative
	if($len <1) return $xe;
	$stpl=$bhsl[2]-$ehsl[2];
	$stpl /=$len;
//	var_dump($bhsl);
	//if(DBG) echo  $stpr.$stpg .$stpb;
	for ($i=0; $i<$len; $i++){
		$x=$xb+$i;
		$l=round(($bhsl[2]-$i*$stpl),0);
		$rgb=HSLToRGB($bhsl[0] ,$bhsl[1] ,$l);
		$color=imagecolorallocatealpha($im, $rgb[0], $rgb[1], $rgb[2], 0);
		imageline($im,$x,0, $x, $h , $color);
	}
	if(DBG) echo  "<br>Period: $period b:$xb e:$xe step:$stpl len:$len light:$bhsl[2]->$ehsl[2] ($l) <br>";
	return $xe;
}	

/*
    HSL to RGB 
	input: array[r,g,b]
*/
if(DBG){
	
	$hsv=array(154,181,228);
	var_dump($hsv);
	var_dump(RGBToHSL($hsv[0], $hsv[1], $hsv[2]));
}

//-----------------------------------------------//
/*
	This module is good for HTML color, round with 255
	It's not necessay if convert back 

function ChangeLuminosity($RGB, $LuminosityPercent)
  {
    $HSL = RGBToHSL($RGB);
    $NewHSL = (int)(((float)$LuminosityPercent / 100) * 255) + (0xFFFF00 & $HSL);
    return HSLToRGB($NewHSL);
  }
*/
function RGBToHSL($r, $g, $b){
	  /*
    $r = 0xFF & ($RGB >> 0x10);
    $g = 0xFF & ($RGB >> 0x8);
    $b = 0xFF & $RGB;

	$r=$rgb[0];
	$g=$rgb[1];
	$b=$rgb[2];
*/
    $r = ((float)$r) / 255.0;
    $g = ((float)$g) / 255.0;
    $b = ((float)$b) / 255.0;

    $maxC = max($r, $g, $b);
    $minC = min($r, $g, $b);

    $l = ($maxC + $minC) / 2.0;

    if($maxC == $minC)
    {
      $s = 0;
      $h = 0;
    }
    else
    {
      if($l < .5)
      {
        $s = ($maxC - $minC) / ($maxC + $minC);
      }
      else
      {
        $s = ($maxC - $minC) / (2.0 - $maxC - $minC);
      }
      if($r == $maxC)
        $h = ($g - $b) / ($maxC - $minC);
      if($g == $maxC)
        $h = 2.0 + ($b - $r) / ($maxC - $minC);
      if($b == $maxC)
        $h = 4.0 + ($r - $g) / ($maxC - $minC);

      $h = $h / 6.0; 
    }

    $h = (int)round(255.0 * $h);
    $s = (int)round(255.0 * $s);
    $l = (int)round(255.0 * $l);

    //$HSL = $l + ($s << 0x8) + ($h << 0x10);
    return array($h ,$s ,$l);
}

function HSLToRGB($h,$s,$l)   {
	 /* 
    $h = 0xFF & ($HSL >> 0x10);
    $s = 0xFF & ($HSL >> 0x8);
    $l = 0xFF & $HSL;

	$h=$hsl[0];
	$s=$hsl[1];
	$l=$hsl[2];
*/	
    $h = ((float)$h) / 255.0;
    $s = ((float)$s) / 255.0;
    $l = ((float)$l) / 255.0;

    if($s == 0)
    {
      $r = $l;
      $g = $l;
      $b = $l;
    }
    else
    {
      if($l < .5)
      {
        $t2 = $l * (1.0 + $s);
      }
      else
      {
        $t2 = ($l + $s) - ($l * $s);
      }
      $t1 = 2.0 * $l - $t2;

      $rt3 = $h + 1.0/3.0;
      $gt3 = $h;
      $bt3 = $h - 1.0/3.0;

      if($rt3 < 0) $rt3 += 1.0;
      if($rt3 > 1) $rt3 -= 1.0;
      if($gt3 < 0) $gt3 += 1.0;
      if($gt3 > 1) $gt3 -= 1.0;
      if($bt3 < 0) $bt3 += 1.0;
      if($bt3 > 1) $bt3 -= 1.0;

      if(6.0 * $rt3 < 1) $r = $t1 + ($t2 - $t1) * 6.0 * $rt3;
      elseif(2.0 * $rt3 < 1) $r = $t2;
      elseif(3.0 * $rt3 < 2) $r = $t1 + ($t2 - $t1) * ((2.0/3.0) - $rt3) * 6.0;
      else $r = $t1;

      if(6.0 * $gt3 < 1) $g = $t1 + ($t2 - $t1) * 6.0 * $gt3;
      elseif(2.0 * $gt3 < 1) $g = $t2;
      elseif(3.0 * $gt3 < 2) $g = $t1 + ($t2 - $t1) * ((2.0/3.0) - $gt3) * 6.0;
      else $g = $t1;

      if(6.0 * $bt3 < 1) $b = $t1 + ($t2 - $t1) * 6.0 * $bt3;
      elseif(2.0 * $bt3 < 1) $b = $t2;
      elseif(3.0 * $bt3 < 2) $b = $t1 + ($t2 - $t1) * ((2.0/3.0) - $bt3) * 6.0;
      else $b = $t1;
    }

    $r = (int)round(255.0 * $r);
    $g = (int)round(255.0 * $g);
    $b = (int)round(255.0 * $b);

    return array($r,$g,$b);
  }

?>