<?php
// Set the content-type
//http://www.swpc.noaa.gov/sites/default/files/images/u2/Usr_guide.pdfheader('Content-Type: image/png');
date_default_timezone_set('America/Los_Angeles');
include (__DIR__ .'/MoonPhase.php');

function Calendar($kp72h, $kp45d){
	$rtime=$kp45d['ftime'];	//time()-date('Z');	//PST Day save time --> UTC
	$issuetime=$kp45d['itime'];
		for($i=0; $i<45; $i++){
			$ap[]=intval(substr($kp45d['kp45d'], $i, 1));
		}
	//	var_dump($ap);
	$thismonth = getdate ($rtime);	//取得当前时间的结构数组
	$startday = $thismonth['wday'];   //day of 1st 第一天星期几
	$showstart=$rtime-$startday*86400;

	define ("REFX",18);	//offset 13
	define ("REFY",202);	//ofset 13
	define ("CW",62);
	define ("CH",61);
	define ("LGX", 16);
	define ("LGY", 593);

	$bgpng=__DIR__ .'/nlc.png';	//278x260
	// Create the image
	$im=imagecreatefrompng($bgpng);
	$moonphase=@imagecreatefrompng(__DIR__ .'/Phases30.png');		//moon phase pic

	// Create some colors
	$white = imagecolorallocate($im, 255, 255, 255);
	$grey = imagecolorallocate($im, 128, 128, 128);
	$black = imagecolorallocate($im, 0, 0, 0);
	$faint = imagecolorallocate($im, 100, 100, 100);
	//$font = 'verdana.ttf';
	//$font = 'Dustismo_Roman_Bold.ttf';
	$font = __DIR__ .'/Arial_Black_Regular.ttf';
	$x=REFX;
	$y=REFY-CH;
	$ckp=array(0,1,2,3,4,5,6,7,8,9) ;
/*
	$ckp[0]=imagecolorallocate($im, 242, 242, 242);		// light gray
	$ckp[1]=imagecolorallocate($im, 217, 217, 217);		//gray
	$ckp[2]=imagecolorallocate($im, 191, 191, 191);		//gray
	$ckp[3]=imagecolorallocate($im, 0, 176, 80);		// green
	$ckp[4]=imagecolorallocate($im, 255, 192, 0);		// orange
	$ckp[5]=imagecolorallocate($im, 255, 0, 00);		//red
	$ckp[6]=imagecolorallocate($im, 175, 0, 33);		// dark red
	$ckp[7]=imagecolorallocate($im, 255, 0, 255);		//magenta
	$ckp[8]=imagecolorallocate($im, 148, 0, 212);		//violet
	$ckp[9]=imagecolorallocate($im, 96, 0, 96);		//purple
*/
	global $kpcolor;

	for ($i=0; $i<10; $i++)
	{
		$c=$kpcolor[(string)$i];
		$ckp[$i]=imagecolorallocate($im, $c['r'], $c['g'], $c['b']);
	}
// Draw legend
	$ktxt=['Q', 'Q', 'Q', 'U', 'A', 'G1', 'G2', 'G3', 'G4', 'G5'];
	for ($i=0; $i<10; $i++)
	{
		$lx=LGX-1;
		$ly=LGY;
		$lw=33;
		imagefilledrectangle($im, $lx+$i*$lw, $ly, $lx+$i*$lw+$lw-1, $ly+42, $ckp[$i]);
		if($i<3)
			imagettftext($im, 16, 0, $lx+$i*$lw+7, $ly+20, $black, $font, (string)$i );
		else
			imagettftext($im, 16, 0, $lx+$i*$lw+7, $ly+20, $white, $font, (string)$i );
		if($i<3)
			imagettftext($im, 14, 0, $lx+$i*$lw+7, $ly+40, $black, $font, $ktxt[$i] );
		else if ($i<5)
			imagettftext($im, 14, 0, $lx+$i*$lw+7, $ly+40, $white, $font, $ktxt[$i] );
		else 
			imagettftext($im, 14, 0, $lx+$i*$lw+3, $ly+40, $white, $font, $ktxt[$i] );
	}
	$dd=date("Y/m/d",$issuetime) ;     //date of update, background color RGB(38,38,38)
	$dt=date("H:i",$issuetime) ." UT"; 
	//imagettftext($im, 14, 00, REFX+CW*4-11, REFY-CH*2-34, $grey, $font, $dd);
	//imagettftext($im, 14, 00, REFX+CW*4+7, REFY-CH*2-14, $grey, $font, $dt);
	imagettftext($im, 12, 00, REFX+CW*4-5, REFY-CH*2-34, $grey, $font, $dd);
	imagettftext($im, 12, 00, REFX+CW*4+7, REFY-CH*2-16, $grey, $font, $dt);

	$j=0;
	$txtx=24;	//date text positioning
	$txty=17;
	for ($i=0; $i<49; $i++) {		//35 days 5 weeks
		if(($i % 7) == 0 ){
			$x=REFX;			//Sunday, begin
			$y+=CH;
			}
		if($i < $startday){
			$dd=date("d",$showstart+$i*86400 );
			imagettftext($im, 15, 00, $x+$txtx, $y-$txty, $faint, $font, $dd);
			$x+=CW;	//skip	gray
		} 
		else {
			$color=$white;
			$kp=$ap[$j];
			if($kp<3) $color=$black;
			imagefilledrectangle($im, $x-2, $y-CH-5, $x+55, $y-13, $ckp[$kp]);
			$dd=date("d",$rtime);
			imagettftext($im, 15, 00, $x+$txtx, $y-$txty, $color, $font, $dd);
			ShowMoonPhase($rtime, $x+4, $y-CH+2, $im, $moonphase);
			$x+=CW;
			$j++;
			$rtime +=86400;
		}
		if($j>=45){
			$i++;
			break;
		} 
	}
	for(; $i<49; $i++)
	{
		$dd=date("d",$showstart+$i*86400 );
		imagettftext($im, 15, 00, $x+$txtx, $y-$txty, $faint, $font, $dd);		//background color RGB(40,40,40)
		$x+=CW;	//skip	gray
	}
	
	imagepng($im, __DIR__ ."/kp/AuroraCalendar.png");
	imagedestroy($im);
	
}

function ShowMoonPhase($time, $x, $y, $im, $moonphase){
	$moondata = phase($time);
	$age=round($moondata[2]);		//moon age
	if($age<0) $age=0;
	$sy=0;
	if ($age>=15) {
		$sy=16;
		$age-=15;
	}
	$sx=$age*16;
	
	imagecopy($im, $moonphase, $x, $y, $sx, $sy, 16, 16 );
	
}

?>