<?php

/* pChart library inclusions */ 
include("../class/pData.class.php"); 
include("../class/pDraw.class.php"); 
include("../class/pImage.class.php"); 

 define ("WINW",240);
 define ("WINH",92);
 define  ("TWR", 30);	//twilight bright
 define  ("TWG", 30);	//twilight bright
 define  ("TWB", 240);	//twilight bright
define ("INH",20);
define ("INV",20);
// Draw area=frame=gradient
define ("FRW",200);
define ("FRH",50);
/* Create and populate the pData object */ 
//$data=array(1,6,6,6,3,3,3,9,0,7,5,5,5,7,7,7);

//$time=time();
//KpNightPlot($data,$time,2);
function KpNightPlot($data,$time,$day){
for($i=0;$i<17;$i++){		//add 1 item
	if($data[$i]==0){
		$Palette[$i]=array("R"=>0,"G"=>0,"B"=>0,"Alpha"=>0);	//black
	} 
	else if($data[$i]>5){
		$Palette[$i]=array("R"=>102,"G"=>0,"B"=>255,"Alpha"=>100);	//purple
	}

	else if($data[$i]>4){
		$Palette[$i]=array("R"=>255,"G"=>0,"B"=>0,"Alpha"=>100);	//red
	}
	else if($data[$i]>3){
		$Palette[$i]=array("R"=>255,"G"=>200,"B"=>0,"Alpha"=>100);	//orange
	}
	else if($data[$i]>2){
		$Palette[$i]=array("R"=>0,"G"=>250,"B"=>0,"Alpha"=>90);	//green
	}
	else $Palette[$i]=array("R"=>200,"G"=>200,"B"=>200,"Alpha"=>80);	//green
}

$MyData = new pData();   
$MyData->addPoints($data,"Today"); 
//$MyData->setAxisName(0,"Today"); 
$MyData->setAxisUnit(0,"kp"); 
$MyData->setAxisDisplay(0,AXIS_FORMAT_CUSTOM,"YAxisFormat"); 

$MyData->addPoints(array("4"," ","6"," ","8"," ","10"," ",
		"0"," ","2"," ","4"," ","6"," ","8"),"Time");

//$MyData->setAxisColor(0,array("R"=>160,"G"=>160,"B"=>160));		// Y Axis only
$MyData->setSerieDescription("Time","clock"); 
$MyData->setAbscissa("Time"); 
$MyData->setXAxisDisplay(AXIS_FORMAT_CUSTOM,"XAxisFormat"); 
/*  to do... use icon to show "kp"
$MyData->setAxisPosition(2,AXIS_POSITION_RIGHT);
$MyData->setAxisName(2,"KP");
*/


/* Create the pChart object */ 
$myPicture = new pImage(WINW,WINH,$MyData); 

/* Draw the background */ 
//$Settings = array("R"=>0, "G"=>150, "B"=>150, "Dash"=>0, "DashR"=>190, "DashG"=>203, "DashB"=>107);
//$myPicture->drawFilledRectangle(0,0,WINW-1,WINH-1,$Settings); 
// $Settings = array("StartR"=>50, "StartG"=>50, "StartB"=>100, "EndR"=>128, "EndG"=>255, "EndB"=>255, "Alpha"=>90);
 $Settings = array("StartR"=>100, "StartG"=>100, "StartB"=>100, "EndR"=>200, "EndG"=>200, "EndB"=>200, "Alpha"=>90);
$myPicture->drawGradientArea(0,0,WINW,WINH,DIRECTION_VERTICAL ,$Settings); 

/* 2 Overlay with a gradient */ 
$Settings = array("StartR"=>TWR, "StartG"=>TWG, "StartB"=>TWB, "EndR"=>1, "EndG"=>1, "EndB"=>64, "Alpha"=>100);
$myPicture->drawGradientArea(INH,INV,INH+FRW/2,INV+FRH,DIRECTION_HORIZONTAL ,$Settings); 
$Settings = array("StartR"=>1, "StartG"=>1, "StartB"=>64, "EndR"=>TWR, "EndG"=>TWG, "EndB"=>TWB, "Alpha"=>100);
$myPicture->drawGradientArea(INH+FRW/2,INV,INH+FRW,INV+FRH,DIRECTION_HORIZONTAL ,$Settings); 
/* Write the picture title */  
$myPicture->setFontProperties(array("FontName"=>"../fonts/DS-DIGIT.ttf","FontSize"=>14));
$time1=date("16:00 "."m/d",$time)."  -  ".date("m/d",$time+86400)." 8:00";
$myPicture->drawText(20,17,$time1,array("R"=>255,"G"=>255,"B"=>255));

/* Add a border to the picture */ 
$myPicture->drawRectangle(INH,INV,INH+FRW/2,INV+FRH,array("R"=>0,"G"=>0,"B"=>0)); 
$myPicture->drawRectangle(INH+FRW/2,INV,INH+FRW,INV+FRH,array("R"=>0,"G"=>0,"B"=>0)); 

/* Define the 1st chart area */ 
$myPicture->setGraphArea(INH,INV,INH+FRW-2,INV+FRH); 
$myPicture->setFontProperties(array("FontName"=>"../fonts/Segment7Standard.otf","FontSize"=>8));
 
/* Draw the scale See: http://wiki.pchart.net/doc.doc.draw.scale.html */ 
$AxisBoundaries = "";
$AxisBoundaries[0] = array("Min"=>0,"Max"=>9);		//manual Y scale

$scaleSettings = array("DrawSubTicks"=>TRUE,"CycleBackground"=>FALSE,"Mode"=>SCALE_MODE_MANUAL, "ManualScale"=>$AxisBoundaries,
		"GridTicks"=>1,"GridR"=>128,"GridG"=>0,"GridB"=>0,"GridAlpha"=>0);
//  不能重复设定，否则影响其它值 GridTicks:虚线长度，0为实线1为点线
$myPicture->drawScale($scaleSettings); 
$settings = array("Surrounding"=>1,"InnerSurrounding"=>0,"Interleave"=>0,"OverrideColors"=>$Palette); 
$myPicture->drawBarChart($settings); 

/* Render the picture (choose the best way) */ 
$time1="nightkp".$day.".png";
//$myPicture->autoOutput($time1); 
$myPicture->render($time1); //save to file
}

function XAxisFormat($Value) {
		if($Value==10) return($Value ." ");		//adjust display position when '10'
			else return ($Value);
}
function YAxisFormat($Value) {
		if($Value==10) return("9");
			else return ($Value);
} 
?>