<?php
/***************************************
  Get one hour pridiction
  
***************************************/

include_once (__DIR__ ."/include/myauroravar.php");

// Set the content-type
//header('Content-Type: image/png');

define ("FONT8SEG", __DIR__ ."/include/Segment7Standard.otf");
define ("FONTTEXT", __DIR__ ."/include/segmono_boot.ttf");
	define ("DBG", 0);

$locID='Vancouver';	
$timezone=$locinfo[$locID][5];

date_default_timezone_set($timezone);

$lati=$locinfo[$locID][2];
$long=$locinfo[$locID][3];;	//Vancouver Latitude and 
$file="http://services.swpc.noaa.gov/images/geospace-3-hour.png";
//$file="http://localhost:8080/mydata/test/geospace-3-hour.png";

$tm=filemtime_remote ($file);
if($tm)
	$ttm=date("Y-m-d H:i:s ",$tm);
else 
	$ttm='Error!';
echo "File modified: $ttm";

// Original PNG 
define ('_oPPK', 20.375);		//128~
define ('_oPPM', 6.044);			//(1216-128)/180=6.0444
define ('_oKpX0',128);
define ('_oKpY0',654);
define ('_oKpY1',648);
define ('_oKp9', 474);
define ('_oTkL', 8);		//long tick size in px
define ('_oTkS', 4);		//short tick size in px
define ('_oGetNow', 3);		//offset to idendify time line

define ('_oG0c', 0x92d050);
define ('_oG1c', 0xf6eb14);
define ('_oG2c', 0xffc800);
define ('_oG3c', 0xff9600);
define ('_oG4c', 0xff0000);
define ('_oG5c', 0xc80000);
define ('_oTNow', 0x9696ff);
define ('_oTEnd', 0xccecdd);
define ('_oTick', 0xffffff);
//

define("_PPK", 12 );
define('_PPM', 6 );
define('_FT', 30);
define('_FB', 8);
define('_FL', 20);
define('_FR', 15);

$imS=imagecreatefrompng ($file);
$width=60*_PPM;
$height=10*_PPK;
$frw=$width+_FL +_FR;
$frh=$height+ _FB +_FT;
$imD=imagecreatetruecolor($frw, $frh);
$bg=imagecolorallocatealpha($imD, 2, 2, 2, 0);
$white=imagecolorallocatealpha($imD, 222, 222, 222, 0);
$light=imagecolorallocatealpha($imD, 100, 100, 100, 0);
if(DBG) echo " white: $white <br>";
imagefilledrectangle($imD, 0, 0, $frw, $frh, $bg);
imagerectangle($imD, 2, 2, $frw-3, $frh-3, $light);
imagerectangle($imD, _FL-1, $frh- _FB +1, _FL+$width-1, _FT, $light);
$data=getTimeNowXY($imS);
$data['time']=$tm;
draw1HourKp($imD, $data);
saveToJson($data);
if(DBG) imagepng($imS, __DIR__ .'/kp/imS.png');
imagepng($imD, __DIR__ .'/kp/oneHour.png');
imagedestroy($imS);
imagedestroy($imD);
if(DBG) {
	echo  ' <img src="kp/imS.png" width=100% />  <br>';		//test
	echo '<br> <img src="kp/oneHour.png"  /> <br>';		//test
}


/********************************************************
//   Functions
*********************************************************/
/*-------------------------------------------------------*/
function getTimeNowXY($imS){
	$tNow=$tEnd=0;
	$x0=_oKpX0;
	$yy=_oKpY0+_oGetNow;
	$lTime=3*60* _oPPM;		//3 hour
//	$red=imagecolorallocatealpha($imS, 222, 2, 2, 0);
//	imageline($imS, $x0, $yy+1, $x0+$lTime, $yy+1, $red);
	for ($x=$x0; $x<($x0+$lTime); $x++){
		$rgb=imagecolorat($imS, $x, $yy);
		if($rgb==_oTNow){
			$tNow=$x;
		}
		else if($rgb==_oTEnd){
			$tEnd=$x;
			break;
		}
			
	}
	$xNow=$tNow;
	$xEnd=$tEnd;
	$tNow=($tNow-_oKpX0+_oPPM-1)/_oPPM;
	$tNow=intval($tNow);
	$tEnd=($tEnd-_oKpX0+_oPPM-1)/_oPPM;
	$tEnd=intval($tEnd);
	$dur=($tEnd-$tNow);
	echo "<br> Now at $tNow, End at $tEnd, Total $dur Mins ";
	$data['now']=$tNow;
	$data['end']=$tEnd;
	$ii=0;	
	$Kps=array();
	// Ignore Kp 9.0, start from 8.7
//	$tNow=120; $tEnd=$tNow+60;		//debug, any period
	for($x=$tNow; $x<$tEnd; $x++){
		$xx=$x*_oPPM+_oKpX0;
		$Kps[$ii]=0;
		$yy=_oKp9;		//8.5, gap _PPK/3=7
		for($y=0; $y<9*3; $y++){ //0-8.7
			$rgb=imagecolorat($imS, $xx, $yy);
//			$trgb=dechex($rgb);
			if($rgb){
				$kp=round((26-$y)/3,1);
				if($kp<0 || $kp>9) $kp=0;	//error
				if($kp>8){
					if($rgb!=_oG5c) $kp=0;	//error
				}
				$Kps[$ii]=$kp;
				break;
			}
			$yy+=_oPPK/3;
		}
		$ii++;
	}
	$km=max($Kps);
	$data['max']=$km;
	$data['Kps']=$Kps;
	echo "  Max: $km";
	return $data;
}
/*-------------------------------------------------------*/

function saveToJson($data){
	$sJson=json_encode($data);
	$fj=__DIR__ .'/kp/oneHour.json';
	$fl=fopen($fj, 'w');
	fwrite($fl, $sJson);
	fclose($fl);
	if(DBG){	
		$fr=fopen($fj, 'r');
		$rj=fread($fr, filesize($fj));
		fclose($fr);
		$dJson=json_decode($rj);
		var_dump($dJson);
	}
}

/*-------------------------------------------------------*/
function draw1HourKp($imD, $data){
	global $kpcolor, $white, $light;
	$min=idate('i', $data['time']);
	$Kps=round ($data['Kps'], 0);
//	if(DBG) var_dump($data);
	$mins=sizeof($data['Kps']);
	if($mins>60) $mins=60;
	$x0=_FL+1;
	$y0=imagesy ($imD)- _FB;
	//$y2=$y0+8;		//tick
	$y2= _FT;
	$cgrid=imagecolorallocatealpha($imD, 50, 50, 50, 47);
	$chide=imagecolorallocatealpha($imD, 20, 20, 20, 0);
	$cred=imagecolorallocatealpha($imD, $kpcolor[5]['r'],
				$kpcolor[5]['g'], $kpcolor[5]['b'], 50);

//	$white=imagecolorallocatealpha($imD, 250, 250, 250, 0);
//	$light=imagecolorallocatealpha($imD, 150, 150, 150, 0);
	for($i=0; $i<=60; $i++){
		if($i<$mins){
			$kp0=$data['Kps'][$i];
			if($kp0){
				$kp=round($kp0, 0);
				$color=imagecolorallocatealpha($imD, $kpcolor[$kp]['r'],
					$kpcolor[$kp]['g'], $kpcolor[$kp]['b'], 0);
				imagefilledrectangle($imD, $x0+$i*_PPM, $y0, $x0+($i+1)*_PPM-2, $y0-$kp0*_PPK, $color);
			}
		}
		$x2=$x0+$i*_PPM-2;
		//time tick
		if($i %5) $y3=$y2+3;
		else {
			$y3=$y2+5;
			if(($i%15)==0)
				imagettftext($imD, 7, 00, $x2-5, $y2-2, $white, FONTTEXT, $i.'\'');
		}
		imageline($imD, $x2, $y2, $x2, $y3, $light);
	}
	
	$x1=imagesx($imD)- _FR;
	$l=$mins*_PPM;
	for ($k=1; $k<10; $k++){	//draw Kp grid
		$y1=$y0-$k* _PPK;
		imageline($imD, $x0, $y1, $x1-2, $y1, $chide);
		if($k==5) imageline($imD, $x0-1, $y1, $x0+$l, $y1, $cred);
		else imageline($imD, $x0-1, $y1, $x0+$l, $y1, $cgrid);
		$color=imagecolorallocatealpha($imD, $kpcolor[$k]['r'],
			$kpcolor[$k]['g'], $kpcolor[$k]['b'], 0);
		//if(($k%2)==1)
		imagettftext($imD, 8, 00, $x0-10, $y1+4, $color, FONTTEXT, $k);
	}
	$max=$data['max'];
	$tm=' update '.gmdate("h:i'",time()).'UT';
	$sm=sprintf("%01.1f", $max );
	$k=round($max, 0);
	$color=imagecolorallocatealpha($imD, $kpcolor[$kp]['r'],
			$kpcolor[$kp]['g'], $kpcolor[$kp]['b'], 0);
	imagettftext($imD, 10, 00, $x0+8, _FT-14, $white, FONTTEXT, '1 hour Kp  (max:    )'.$tm);
	imagettftext($imD, 12, 00, $x0+137, _FT-13, $color, FONTTEXT, $sm);
}



/*-------------------------------------------------------*/
function filemtime_remote($uri)
{
    $uri = parse_url($uri);
//	var_dump($uri);
	if(isset($uri['port']))	
		$port=$uri['port'];		//could be 8080
	else 
		$port=80;		
    $handle = @fsockopen($uri['host'],$port);
    if(!$handle)
        return 0;

    fputs($handle,"GET $uri[path] HTTP/1.1\r\nHost: $uri[host]\r\n\r\n");
    $result = 0;
    while(!feof($handle))
    {
        $line = fgets($handle,1024);
        if(!trim($line))
            break;

        $col = strpos($line,':');
        if($col !== false)
        {
            $header = trim(substr($line,0,$col));
            $value = trim(substr($line,$col+1));
            if(strtolower($header) == 'last-modified')
            {
                $result = strtotime($value);
                break;
            }
        }
    }
    fclose($handle);
    return $result;
}
// echo filemtime_remote('http://www.somesite.com/someimage.jpg');



?>