<!--   ------------------------ Part1 Get 45-day data to $ap{}---------------------------->

<?php 
/* Kp and Ap  http://www.ngdc.noaa.gov/stp/GEOMAG/kp_ap.html
    Kp = 0o     0+   1-   1o   1+   2-   2o 2  2+ 2+ 2+ 3-   3o   3+   4-   4o   4+
	ap =  0  1  2    3    4    5    6    7  8  9  10 11 12   15   18   22   27   32

	Kp = 5-   5o   5+   6-   6o   6+   7-   7o   7+   8-   8o   8+   9-   9o
	ap = 39   48   56   67   80   94  111  132  154  179  207  236  300  400
https://www.spaceweatherlive.com/en/auroral-activity/aurora-forecast
high latitude and middle
*/
date_default_timezone_set('America/Los_Angeles');
header('Content-type: text/html');
//        0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25
$kp=array(0,0,1,1,1,2,2,2,3,3,4, 4, 4, 4, 4, 5,5,5);
//echo '<pre>';	// <pre> keep blank space.
//echo '<div style="text-align:center;width:320px;height:130px;font-size:14px"> '; 
//echo date('Y-m-d H:i:s \n');
//printf ("%d \n", time());
//echo '<span style="color:red">这是红色的字</span>';
$file="http://services.swpc.noaa.gov/text/45-day-ap-forecast.txt";
//$file="http://dajiguang.com/exdiy/45-day-ap-forecast.txt";
$lines = file($file);

$i=0;
$array="";
foreach($lines as $line) {
 $line = rtrim($line);
 $array[$i]=$line;
 $i++;
}

$d=0;
$ap=array();
//	echo date('m/d   ',$t);

function GetRowData($sin){
	global $kp,$ap,$d;
	$ap[$d++]=intval(substr($sin,8,3));
	$ap[$d++]=intval(substr($sin,21,3));
	$ap[$d++]=intval(substr($sin,33,3));
	$ap[$d++]=intval(substr($sin,45,3));
	$ap[$d++]=intval(substr($sin,57,3));
}


function Ap2Kp(){
	global $ap,$kp,$a1;
	for ($i=0;$i<30;$i++){
		$k=$ap[$i];
		if($k>=15) $k=15;
		$ap[$i]=$kp[$k];
		if($ap[$i]>3) $a1++;
  }
}

function prRow($j){
	global $ap,$d;
	for($i=0;$i<5;$i++){
		$k=$ap[$d];
		if($k>4){
			echo '<span style="color:red">';
		}
		else if ($k>3) {
				echo '<span style="color:#ff8000">';	//oringe
		}
		else{
			echo '<span style="color:#ccc">';
		}
		echo date("m/d=",$j+$i*86400);
	
		printf("%d ",$k);
		echo '</span>';
		$d++;
	}
	echo'<br>';
}
//-------------- run -----------//
//start date
$date1=strtotime(substr($array[10],0,7));
//echo 'Y'.substr($array[1],9,4).'M'.substr($array[1],14,3);
//echo 'D'.substr($array[1],18,2).'h'.substr($array[1],21,4);
//echo date("Y-M-d",$date1);
$s=substr($array[1],9,4).'-'.substr($array[1],14,3).'-'.substr($array[1],18,2).' '.substr($array[1],21,2).':'.substr($array[1],23,2);
//echo $s;
$issuetime=strtotime($s)+date('Z');
//print_r(date_parse(substr($array[1],9,16)));
//echo date("更新时间：Y.m.d H:i",$issuetime);

//Get 30 days data to ap$[]
$d=0;
for ($i=10;$i<19;$i++){
    GetRowData($array[$i]);
}
// convert ap to kp
$a1=0;
Ap2Kp();
//print_r($ap);
//-------------- Display data --------------//

//display 30 day kp
//$a1=0; test
/*
if($a1){
	echo '<span style="color:#ff8000">';
	printf("未来30天内极光活跃天数：%d天 <br>",$a1);
	echo '</span> <span style="color:#ccc">';
	echo '请关注以下日期：';
}
else {
	echo '<span style="color:#ccc">';
	echo '预计未来30天内极光不活跃<br>';
}
echo '<br>';
$d=0;
for($j=0;$j<6;$j++){
//	echo date("m/d ",$date1+$j*86400);
	prRow($j*5*86400+$date1);
//	$date1+=5*86400;
}
*/
//-------------- Display storm alert --------------//

//echo '</div></pre>';


	
?>

<!--   ------------------------ Part2 Calendar ----------------------------------------->

<?php
//$date1+=5*86400;      //test
// Data from previous: $ap[];$date1;
/*$monthNames = Array("January", "February", "March", "April", "May", "June", "July", 
"August", "September", "October", "November", "December");
*/
?>


<?php
if (!isset($_REQUEST["month"])) $_REQUEST["month"] = date("n");
if (!isset($_REQUEST["year"])) $_REQUEST["year"] = date("Y");
?>

<?php
$YVRlati=49.304;
$YVRlong=-123.144;	//Vancouver Latitude and Longitude

$rtime=time();	//PST Day save time
$rtime=$date1;
//echo date('Y-m-d H:i:s ', $rtime);

//$thismonth = getdate ($rtime);	//取得当前时间的结构数组
//printf("%d",$thismonth['wday']);

/* Sun infomaition
$sun_info = date_sun_info($rtime, $YVRlati, $YVRlong);
foreach ($sun_info as $key => $val) {
    echo "$key: " . date("H:i:s", $val) . "\n";
}
*/

$cMonth = date("m",$rtime);	//$_REQUEST["month"];
$cYear = date("Y",$rtime);	//$_REQUEST["year"];
 
 
$prev_year = $cYear;
$next_year = $cYear;
$prev_month = $cMonth-1;
$next_month = $cMonth+1;
 
if ($prev_month == 0 ) {
    $prev_month = 12;
    $prev_year = $cYear - 1;
}
if ($next_month == 13 ) {
    $next_month = 1;
    $next_year = $cYear + 1;
}
?>
<!-- Day tile -->
<table width="200" border="1" cellspacing="0" cellpadding="0">
<tr align="center">
<td bgcolor="#fff" style="color:#FFFFFF">
<table width="100%" border="0" cellspacing="0" cellpadding="0">
<tr>
<!--
<td width="50%" align="left">  <a href="<?php echo $_SERVER["PHP_SELF"] . "?month=". $prev_month . "&year=" . $prev_year; ?>" style="color:#FFFFFF">Previous</a></td>
<td width="50%" align="right"><a href="<?php echo $_SERVER["PHP_SELF"] . "?month=". $next_month . "&year=" . $next_year; ?>" style="color:#FFFFFF">Next</a>  </td >
 -->
</tr>
</table>
</td>
</tr>
<tr>
<td align="center">
<table width="100%" border="0" cellpadding="2" cellspacing="2">
<tr align="center">
<td colspan="7" bgcolor="#999999" style="color:white"><strong><?php echo date("Y-m-d H:i ",$issuetime/*$rtime*/); ?></strong></td>
</tr>
<tr>  <!--week day name -->
<td align="center" bgcolor="#999999" style="color:#FFFFFF"><strong>日</strong></td>
<td align="center" bgcolor="#999999" style="color:#FFFFFF"><strong>一</strong></td>
<td align="center" bgcolor="#999999" style="color:#FFFFFF"><strong>二</strong></td>
<td align="center" bgcolor="#999999" style="color:#FFFFFF"><strong>三</strong></td>
<td align="center" bgcolor="#999999" style="color:#FFFFFF"><strong>四</strong></td>
<td align="center" bgcolor="#999999" style="color:#FFFFFF"><strong>五</strong></td>
<td align="center" bgcolor="#999999" style="color:#FFFFFF"><strong>六</strong></td>
</tr>

<?php 
//$timestamp = mktime(0,0,0,$cMonth,1,$cYear);
//$maxday = date("t",$timestamp);		//本月天数
$thismonth = getdate ($rtime);	//取得当前时间的结构数组
$startday = $thismonth['wday'];   //day of 1st 第一天星期几
$j=0;		//count
$bgc=array("white","white","white","white","orange","red");		//red
for ($i=0; $i<(30+$startday); $i++) {
    if(($i % 7) == 0 ) echo "<tr>";
    if($i < $startday) echo "<td></td>";
    else {
		echo "<td align='center' valign='middle' height='20px' bgcolor='";
		echo $bgc[$ap[$j]];
		echo "' >". date("d",$rtime). "</td>";
		$rtime +=86400;
		$j++;
	}
		if(($i % 7) == 6 ) echo "</tr>";
	}
?>
</table>
</td>
</tr>
</table>