<?php

//http://www.ec.gc.ca/meteo-weather/default.asp?lang=En&n=10220A6B-1#c1
// Canada weather definitions

// Parse the transparency status to file. Use filemtime() to check update
// filename as location_trans.log
$palette=[
/*'id' => 'JASC-PAL',
'na' => '0100',
'depth' => 16,  */
 [0, 62, 126],
 [43,107,171],
 [98,162,226],
 [148,212,212],
 [198,198,198],
 [254,254,254],
 [0,0,0],
 //[255,255,255],
 //[43,107,171],
];


//https://weather.gc.ca/astro/transparence_e.html
// map file url: https://weather.gc.ca/data/prog/regional/



$url="https://weather.gc.ca/data/prog/regional/";
$path="2017032100/";
// file name: yyyymmddHH/yyyymmddHH_054__R1_north@america@astro_I_ASTRO_transp_hhh.png
// 
$filename="2017032012_054_R1_north@america@astro_I_ASTRO_transp_003.png";
// (x,y, lat, lon) coor on transparency map
$citycoor=[
	"Yellowknife"	=> [221, 173, 62.46, -114.3],
	"Vancouver"		=> [146 ,312, 49.26, -123.14],
	"Edmonton"		=> [220, 275, 53.28, -113.45],
	"Test"			=> [216, 109, 0,  0],
];
$vancouversites=[
 	["Vancouver", 146 ,312, 49.26,-123.14],
	["Squamish",  148, 307, 49.7, -123.15],
    ["PittLake",  150, 311, 49.41,-122.65],
    ["MtBaker",   155, 319, 48.92,-121.71],
    ["Manning",   164, 318, 49.11,-120.83],
    ["Merritt",   165, 305, 50.16,-120.84],

];
$fp="transparency/vancouver.csv";
ArrayToCSV($fp, $vancouversites);
$csv=arrayFromCSV($fp);

//var_dump($vancouversites);
echo '<br> =====================<br>';
//var_dump($csv);
$city="Vancouver";
$country="CA"; //Two digit country code
// log in: myang67@gmail.com zx
//Get current Temperature in Celsius
//echo $json."<br>";
//var_dump($data);	
$trmap=imagecreatefrompng($filename);

$x=$citycoor["Test"][0];
$y=$citycoor["Test"][1];
$icolor=imagecolorat ( $trmap, $x, $y);

echo 'color idex: '. $icolor;
list($r, $g, $b) = sscanf($icolor, "#%02x%02x%02x");
echo " $icolor -> $r $g $b";
var_dump(imagecolorsforindex($trmap, $icolor));

echo "<br>";

echo "<br>";
//imagecolorresolve() doesn't work to identify similar color
for($i=0; $i<count($palette); $i++){
		$ic2=($palette[$i][0]<<16)+($palette[$i][1]<<8)+$palette[$i][2];
		$dif=colorSimilar($icolor,$ic2);
		if($dif <145) break;
}
if($i==count($palette)) 
	echo "out. $dif";
else 
	echo "Transparency lever: $i($dif)";

/* =========================== Functions ======================================== */
/* Save array to CSV file
*/
function ArrayToCSV($fp, $arry){
	$fh=fopen($fp, 'c+');	//folder must be created
// Generate CSV data from array
	//fputcsv($fh, array_keys(($arry)));
     //write out the data
        foreach ( $arry as $key => $row ) {
                fputcsv($fh, $row);
        }
   //     rewind($fh);
        //$csv = stream_get_contents($fh);
        $csv=fgetcsv($fh);
		fclose($fh);

	echo '<br>';		
	//print_r($vancouversites);
	echo '<br>';
	var_dump ($csv);
}

/* Load array from CSV file
  Forget to try get keys save and restore. string to be convert to int/float
*/
function arrayFromCSV($fp){
		$fh=fopen($fp, 'r+');	//folder must be created
// Generate CSV data from array
        //$csv = stream_get_contents($fh);
        while (!feof($fh)){
			$csv[]=fgetcsv($fh);
		}
		fclose($fh);
		return $csv;
}



/*  make 145 acceptable (green offset:6~144, 5~100) 
*/
function colorSimilar($ic1, $ic2){
	$red1 = ($ic1>> 16) & 0xFF;
	$green1 = ($ic1 >> 8) & 0xFF;
	$blue1 = $ic1 & 0xFF;	
	$red2 = ($ic2>> 16) & 0xFF;
	$green2 = ($ic2 >> 8) & 0xFF;
	$blue2 = $ic2 & 0xFF;	
	$dr = $red1   - $red2;
	$dg = $green1 - $green2;
	$db = $blue1  - $blue2;
	$fr = 2; // may be adjusted
	$fg = 4; // "
	$fb = 1; // "
	$distance_squared = $fr * $dr * $dr + $fg * $dg * $dg + $fb * $db * $db;	
	return $distance_squared;	
}

?>